#include <openGLCD.h> // подключаем библиотеку для ЛСД дисплея 128*64
#include <si5351.h> // подключаем библиотеку для СИ5351
#include "Wire.h"   // подключаем библиотеку для работы с шиной И2Ц

#include <math.h>

//переменные для энкодера
volatile unsigned char encoder_A, encoder_B, encoder_A_prev;

int Button; // назначаем кнопку на переключение режимов
int Button1 = 12; //пин к которой подключена кнопка энкодера

int ExitButton = 19; //назначение пина для кнопки EXIT
volatile int ExitStat = 0;
volatile int ExitStat2 = 0;
volatile int ExitStat3 = 0;
volatile int ExitMark = 0;

volatile int F = 0;          // назначаем переменную для оси Y
volatile int PosDot = 0;     // назначаем переменную для оси Х

Si5351 si5351;

volatile float  startFreq;
volatile float  centrFreq = 1070000000;
volatile float  centrFreq1;
volatile float  startFreq1;
volatile float  stepCentrFreq;
volatile float  stepCentrFreq1;

volatile unsigned long  maxFreq = 0;
volatile unsigned long  polosaFreq = 100000000;
volatile float  LCDFreq;
volatile float  LCDFreq2;
volatile unsigned long  polosaACH; //переменная для хранения ширины АЧХ
volatile float  stepFreq; //шаг перестройки частоты

volatile float stepFreq1;
volatile unsigned long  FreqACH;

//переменные для установки и перестройки шага частоты
volatile unsigned long Step = 1000000;
int StepButton;
int StepButton1 = 11; //пин к которой подключена кновка установка шага перестройки

//переменные для стартового меню
volatile int Menu = 1;

//переменные для маркера на дисплее
volatile float Marker = 63;
volatile float MarkerFreq;
volatile float  stepMarker; //шаг перестройки частоты

//переменные для режима изменения стартовой частоты в режиме измерения
int ChangeButton = 18; //назначение кнопки для переключения режимов просмотра АЧХ
volatile int ChangeStat = 1;
volatile float NewCentrFreq;

//переменные для регулировки амплитуды АЧХ
volatile int StartU = 216;
//volatile int Power_SI5351 = SI5351_DRIVE_4MA;
int Button2 = 5; //кнопка для установки МОЩНОСТИ генератора
int Button2_2;
int PWR = 50;
int PWR_STAT = 50;

void setup() {
  Serial.begin(9600);

  GLCD.Init(); // инициализация ЛСД дисплея
  pinMode(2, INPUT_PULLUP);
  pinMode(3, INPUT_PULLUP);
  pinMode(Button1, INPUT_PULLUP);
  pinMode(Button2, INPUT_PULLUP);
  pinMode(A0, INPUT); // назначаем порт А на вход аналогового сигнала
  pinMode(StepButton1, INPUT_PULLUP);
  pinMode(ExitButton, INPUT_PULLUP);
  pinMode(ChangeButton, INPUT_PULLUP);

  si5351.init(SI5351_CRYSTAL_LOAD_8PF, 0, 0); // инициализация СИ5351
  si5351.drive_strength(SI5351_CLK0, SI5351_DRIVE_4MA); //настраиваем выход модуля на макс мощность (возможные вариант 2, 4, 6, 8)
  si5351.set_freq(startFreq, SI5351_CLK0);

  //ЗАСТАВКА
  GLCD.SelectFont(Callibri11_bold);
  GLCD.DrawRect(0, 0, 128, 64, BLACK);
  GLCD.CursorTo(2, 1);
  GLCD.print("The meter AFC");
  GLCD.CursorTo(1, 2);
  GLCD.print("by Alex Grabovenko");
  GLCD.CursorTo(4, 3);
  GLCD.print("Ver. 1.35");
  GLCD.CursorTo(4, 4);
  GLCD.print("UB6HMV");
  delay(1000);
  GLCD.ClearScreen();
}

void loop() {
  PresetFreq();
}

// Функция МЕНЮ ПРЕСЕТОВ центральной частоты
void PresetFreq() {
  GLCD.SelectFont(Callibri11_bold);
  detachInterrupt(0);
  detachInterrupt(1);
  detachInterrupt(4);
  attachInterrupt(0, MenuGetAFC, FALLING); //отработка функции энкодера для выбора пункта меню
  attachInterrupt(1, MenuGetAFC, FALLING);

  Button = digitalRead(Button1);

  while (Menu == 1 && ExitStat3 == 0) {
    delay(50);
    if (ExitMark == 1) {
      attachInterrupt(0, MenuGetAFC, FALLING); //отработка функции энкодера для выбора пункта меню
      attachInterrupt(1, MenuGetAFC, FALLING);
      detachInterrupt(4);
      ExitMark = 0;
      ExitStat = 0;
    }
    if (ExitStat3 == 1) return;
    GLCD.CursorTo(0, 0);
    GLCD.print("     <SELECT PRESET>");
    GLCD.CursorTo(0, 2);
    GLCD.print("1. Man. Set FRQ     ");
    Button = digitalRead(Button1);
    if (Button == LOW) {
      GLCD.ClearScreen();
      delay(200);
      Step = 100000;
      centrFreq = 1070000000;
      ChangeStat = 1;
      SetCentrFreq();
    }
  }

  while (Menu == 2) {
    delay(50);
    if (ExitMark == 1) {
      attachInterrupt(0, MenuGetAFC, FALLING); //отработка функции энкодера для выбора пункта меню
      attachInterrupt(1, MenuGetAFC, FALLING);
      detachInterrupt(4);
      ExitMark = 0;
      ExitStat = 0;
    }
    if (ExitStat3 == 1) return;
    GLCD.CursorTo(0, 0);
    GLCD.print("     <SELECT PRESET>");
    GLCD.CursorTo(0, 2);
    GLCD.print("2. 160 m BAND       ");
    Button = digitalRead(Button1);
    if (Button == LOW) {
      GLCD.ClearScreen();
      ChangeStat = 1;
      BAND_160();
    }
  }

  while (Menu == 3) {
    delay(50);
    if (ExitMark == 1) {
      attachInterrupt(0, MenuGetAFC, FALLING); //отработка функции энкодера для выбора пункта меню
      attachInterrupt(1, MenuGetAFC, FALLING);
      detachInterrupt(4);
      ExitMark = 0;
      ExitStat = 0;
    }
    if (ExitStat3 == 1) return;
    GLCD.CursorTo(0, 0);
    GLCD.print("     <SELECT PRESET>");
    GLCD.CursorTo(0, 2);
    GLCD.print("3. 80 m BAND        ");
    Button = digitalRead(Button1);
    if (Button == LOW) {
      GLCD.ClearScreen();
      ChangeStat = 1;
      BAND_80();
    }
  }

  while (Menu == 4) {
    delay(50);
    if (ExitMark == 1) {
      attachInterrupt(0, MenuGetAFC, FALLING); //отработка функции энкодера для выбора пункта меню
      attachInterrupt(1, MenuGetAFC, FALLING);
      detachInterrupt(4);
      ExitMark = 0;
      ExitStat = 0;
    }
    if (ExitStat3 == 1) return;
    GLCD.CursorTo(0, 0);
    GLCD.print("     <SELECT PRESET>");
    GLCD.CursorTo(0, 2);
    GLCD.print("4. 40 m BAND        ");
    Button = digitalRead(Button1);
    if (Button == LOW) {
      GLCD.ClearScreen();
      ChangeStat = 1;
      BAND_40();
    }
  }

  while (Menu == 5) {
    delay(50);
    if (ExitMark == 1) {
      attachInterrupt(0, MenuGetAFC, FALLING); //отработка функции энкодера для выбора пункта меню
      attachInterrupt(1, MenuGetAFC, FALLING);
      detachInterrupt(4);
      ExitMark = 0;
      ExitStat = 0;
    }
    if (ExitStat3 == 1) return;
    GLCD.CursorTo(0, 0);
    GLCD.print("     <SELECT PRESET>");
    GLCD.CursorTo(0, 2);
    GLCD.print("5. 20 m BAND        ");
    Button = digitalRead(Button1);
    if (Button == LOW) {
      GLCD.ClearScreen();
      ChangeStat = 1;
      BAND_20();
    }
  }

  while (Menu == 6) {
    delay(50);
    if (ExitMark == 1) {
      attachInterrupt(0, MenuGetAFC, FALLING); //отработка функции энкодера для выбора пункта меню
      attachInterrupt(1, MenuGetAFC, FALLING);
      detachInterrupt(4);
      ExitMark = 0;
      ExitStat = 0;
    }
    if (ExitStat3 == 1) return;
    GLCD.CursorTo(0, 0);
    GLCD.print("     <SELECT PRESET>");
    GLCD.CursorTo(0, 2);
    GLCD.print("6. 15 m BAND        ");
    Button = digitalRead(Button1);
    if (Button == LOW) {
      GLCD.ClearScreen();
      ChangeStat = 1;
      BAND_15();
    }
  }

  while (Menu == 7) {
    delay(50);
    if (ExitMark == 1) {
      attachInterrupt(0, MenuGetAFC, FALLING); //отработка функции энкодера для выбора пункта меню
      attachInterrupt(1, MenuGetAFC, FALLING);
      detachInterrupt(4);
      ExitMark = 0;
      ExitStat = 0;
    }
    if (ExitStat3 == 1) return;
    GLCD.CursorTo(0, 0);
    GLCD.print("     <SELECT PRESET>");
    GLCD.CursorTo(0, 2);
    GLCD.print("7. 10 m BAND        ");
    Button = digitalRead(Button1);
    if (Button == LOW) {
      GLCD.ClearScreen();
      ChangeStat = 1;
      BAND_10();
    }
  }

  while (Menu == 8) {
    delay(50);
    if (ExitMark == 1) {
      attachInterrupt(0, MenuGetAFC, FALLING); //отработка функции энкодера для выбора пункта меню
      attachInterrupt(1, MenuGetAFC, FALLING);
      detachInterrupt(4);
      ExitMark = 0;
      ExitStat = 0;
    }
    if (ExitStat3 == 1) return;
    GLCD.CursorTo(0, 0);
    GLCD.print("     <SELECT PRESET>");
    GLCD.CursorTo(0, 2);
    GLCD.print("8. 455 kHz          ");
    Button = digitalRead(Button1);
    if (Button == LOW) {
      GLCD.ClearScreen();
      ChangeStat = 1;
      FILTRE_455();
    }
  }

  while (Menu == 9) {
    delay(50);
    if (ExitMark == 1) {
      attachInterrupt(0, MenuGetAFC, FALLING); //отработка функции энкодера для выбора пункта меню
      attachInterrupt(1, MenuGetAFC, FALLING);
      detachInterrupt(4);
      ExitMark = 0;
      ExitStat = 0;
    }
    if (ExitStat3 == 1) return;
    GLCD.CursorTo(0, 0);
    GLCD.print("     <SELECT PRESET>");
    GLCD.CursorTo(0, 2);
    GLCD.print("9. 465 kHz          ");
    Button = digitalRead(Button1);
    if (Button == LOW) {
      GLCD.ClearScreen();
      ChangeStat = 1;
      FILTRE_465();
    }
  }

  while (Menu == 10) {
    delay(50);
    if (ExitMark == 1) {
      attachInterrupt(0, MenuGetAFC, FALLING); //отработка функции энкодера для выбора пункта меню
      attachInterrupt(1, MenuGetAFC, FALLING);
      detachInterrupt(4);
      ExitMark = 0;
      ExitStat = 0;
    }
    if (ExitStat3 == 1) return;
    GLCD.CursorTo(0, 0);
    GLCD.print("     <SELECT PRESET>");
    GLCD.CursorTo(0, 2);
    GLCD.print("10. 500 kHz         ");
    Button = digitalRead(Button1);
    if (Button == LOW) {
      GLCD.ClearScreen();
      ChangeStat = 1;
      FILTRE_500();
    }
  }

  while (Menu == 11) {
    delay(50);
    if (ExitMark == 1) {
      attachInterrupt(0, MenuGetAFC, FALLING); //отработка функции энкодера для выбора пункта меню
      attachInterrupt(1, MenuGetAFC, FALLING);
      detachInterrupt(4);
      ExitMark = 0;
      ExitStat = 0;
    }
    if (ExitStat3 == 1) return;
    GLCD.CursorTo(0, 0);
    GLCD.print("     <SELECT PRESET>");
    GLCD.CursorTo(0, 2);
    GLCD.print("11. 5,5 MHz         ");
    Button = digitalRead(Button1);
    if (Button == LOW) {
      GLCD.ClearScreen();
      ChangeStat = 1;
      FILTRE_5_5();
    }
  }

  while (Menu == 12) {
    delay(50);
    if (ExitMark == 1) {
      attachInterrupt(0, MenuGetAFC, FALLING); //отработка функции энкодера для выбора пункта меню
      attachInterrupt(1, MenuGetAFC, FALLING);
      detachInterrupt(4);
      ExitMark = 0;
      ExitStat = 0;
    }
    if (ExitStat3 == 1) return;
    GLCD.CursorTo(0, 0);
    GLCD.print("     <SELECT PRESET>");
    GLCD.CursorTo(0, 2);
    GLCD.print("12. 6,5 MHz         ");
    Button = digitalRead(Button1);
    if (Button == LOW) {
      GLCD.ClearScreen();
      ChangeStat = 1;
      FILTRE_6_5();
    }
  }

  while (Menu == 13) {
    delay(50);
    if (ExitMark == 1) {
      attachInterrupt(0, MenuGetAFC, FALLING); //отработка функции энкодера для выбора пункта меню
      attachInterrupt(1, MenuGetAFC, FALLING);
      detachInterrupt(4);
      ExitMark = 0;
      ExitStat = 0;
    }
    if (ExitStat3 == 1) return;
    GLCD.CursorTo(0, 0);
    GLCD.print("     <SELECT PRESET>");
    GLCD.CursorTo(0, 2);
    GLCD.print("13. 8,86 MHz        ");
    Button = digitalRead(Button1);
    if (Button == LOW) {
      GLCD.ClearScreen();
      ChangeStat = 1;
      FILTRE_8_86();
    }
  }

  while (Menu == 14) {
    delay(50);
    if (ExitMark == 1) {
      attachInterrupt(0, MenuGetAFC, FALLING); //отработка функции энкодера для выбора пункта меню
      attachInterrupt(1, MenuGetAFC, FALLING);
      detachInterrupt(4);
      ExitMark = 0;
      ExitStat = 0;
    }
    if (ExitStat3 == 1) return;
    GLCD.CursorTo(0, 0);
    GLCD.print("     <SELECT PRESET>");
    GLCD.CursorTo(0, 2);
    GLCD.print("14. 10,7 MHz        ");
    Button = digitalRead(Button1);
    if (Button == LOW) {
      GLCD.ClearScreen();
      ChangeStat = 1;
      FILTRE_10_7();
    }
  }
}

//ФУНКЦИЯ РУЧНОЙ УСТАНОВКИ ЦЕНТРАЛЬНОЙ ЧАСТОТЫ ИЗМЕРЕНИЯ АЧХ
void SetCentrFreq() {
  GLCD.SelectFont(System5x7); //шрифт текста

  if (ExitStat == 1) centrFreq = centrFreq1 + stepCentrFreq; //восстанавливаем начальное значение старотовой частоты

  ExitStat = 0;
  ChangeStat = 1;
  Button = digitalRead(Button1);

  while (Button == HIGH && ExitStat2 == 0) {
    Button = digitalRead(Button1);

    LCDFreq = (float)centrFreq / 100000.00;
    GLCD.CursorTo(0, 0);
    GLCD.print("Set centr freq:");
    GLCD.CursorTo(0, 3);
    GLCD.print(LCDFreq);
    GLCD.print(" kHz");

    attachInterrupt(0, Encoder2, FALLING); //отработка функции энкодера для установки СТАРТОВОЙ частоты
    attachInterrupt(1, Encoder2, FALLING);
    si5351.set_freq(centrFreq, SI5351_CLK0); //отправляем значение полученной частоты в синтезатор частоты

    //установка шага перестройки
    StepButton = digitalRead(StepButton1);
    if (StepButton == LOW && Step == 100000000) {
      delay(400);
      GLCD.CursorTo(0, 6);
      GLCD.print("Step freq:    1 kHz");
      Step = 100000;
    }

    StepButton = digitalRead(StepButton1);
    if (StepButton == LOW && Step == 100000) {
      delay(400);
      GLCD.CursorTo(0, 6);
      GLCD.print("Step freq:   10 kHz");
      Step = 1000000;
    }

    StepButton = digitalRead(StepButton1);
    if (StepButton == LOW && Step == 1000000) {
      delay(400);
      GLCD.CursorTo(0, 6);
      GLCD.print("Step freq:  100 kHz");
      Step = 10000000;
    }

    StepButton = digitalRead(StepButton1);
    if (StepButton == LOW && Step == 10000000) {
      delay(400);
      GLCD.CursorTo(0, 6);
      GLCD.print("Step freq: 1000 kHz");
      Step = 100000000;
    }

    Button = digitalRead(Button1);
    if (Button == LOW) {
      WIDT();
    }
  }
}

//ФУНКЦИЯ УСТАНОВКИ ШИРИНЫ ПОЛОСЫ СКАНИРОВАНИЯ
void WIDT() {
  detachInterrupt(4);
  GLCD.ClearScreen();
  delay(400);
  Button = digitalRead(Button1);
  Button2_2 = digitalRead(Button2);
  attachInterrupt(0, Encoder3, FALLING); //отработка функции энкодера для установки ПОЛОСЫ сканирования
  attachInterrupt(1, Encoder3, FALLING);

  while (Button == HIGH && ExitStat2 == 0) {

    Button = digitalRead(Button1); // проверяем нажатие кнопки установки ШАГА установки чатсоты

    LCDFreq2 = (float)polosaFreq / 100000.00;
    GLCD.CursorTo(0, 0);
    GLCD.print("Set width's freq:");
    GLCD.CursorTo(0, 3);
    GLCD.print(LCDFreq2);
    GLCD.print(" kHz");
    GLCD.CursorTo(0, 5);
    GLCD.print(PWR_STAT);
    GLCD.print(" % PWR Si5351 ");


    //установка шага перестройки
    StepButton = digitalRead(StepButton1);
    if (StepButton == LOW && Step == 100000000) {
      delay(400);
      GLCD.CursorTo(0, 7);
      GLCD.print("Step freq:    1 kHz");
      Step = 100000;
    }

    StepButton = digitalRead(StepButton1);
    if (StepButton == LOW && Step == 100000) {
      delay(400);
      GLCD.CursorTo(0, 7);
      GLCD.print("Step freq:   10 kHz");
      Step = 1000000;
    }

    StepButton = digitalRead(StepButton1);
    if (StepButton == LOW && Step == 1000000) {
      delay(200);
      GLCD.CursorTo(0, 7);
      GLCD.print("Step freq:  100 kHz");
      Step = 10000000;
    }

    StepButton = digitalRead(StepButton1);
    if (StepButton == LOW && Step == 10000000) {
      delay(200);
      GLCD.CursorTo(0, 7);
      GLCD.print("Step freq: 1000 kHz");
      Step = 100000000;
    }

    //установка МОЩНОСТИ сигнала генератора
    Button2_2 = digitalRead(Button2); // проверяем нажатие кнопки изменения МОЩНОСТИ генератора
    if (Button2_2 == LOW && PWR == 25) {
      delay(400);
      PWR_STAT = 25;
      si5351.drive_strength(SI5351_CLK0, SI5351_DRIVE_2MA); //настраиваем выход модуля на макс мощность (возможные вариант 2, 4, 6, 8)
      PWR = 50;
    }

    Button2_2 = digitalRead(Button2); // проверяем нажатие кнопки изменения МОЩНОСТИ генератора
    if (Button2_2 == LOW && PWR == 50) {
      delay(400);
      PWR_STAT = 50;
      si5351.drive_strength(SI5351_CLK0, SI5351_DRIVE_4MA); //настраиваем выход модуля на макс мощность (возможные вариант 2, 4, 6, 8)
      PWR = 75;
    }

    Button2_2 = digitalRead(Button2); // проверяем нажатие кнопки изменения МОЩНОСТИ генератора
    if (Button2_2 == LOW && PWR == 75) {
      delay(400);
      PWR_STAT = 75;
      si5351.drive_strength(SI5351_CLK0, SI5351_DRIVE_6MA); //настраиваем выход модуля на макс мощность (возможные вариант 2, 4, 6, 8)
      PWR = 100;
    }

    Button2_2 = digitalRead(Button2); // проверяем нажатие кнопки изменения МОЩНОСТИ генератора
    if (Button2_2 == LOW && PWR == 100) {
      delay(400);
      PWR_STAT = 100;
      si5351.drive_strength(SI5351_CLK0, SI5351_DRIVE_8MA); //настраиваем выход модуля на макс мощность (возможные вариант 2, 4, 6, 8)
      PWR = 25;
    }

    Button = digitalRead(Button1);
    if (Button == LOW) {
      Button = digitalRead(Button1);
      AFC();
    }
  }
}

// ФУНКЦИЯ РЕЖИМА ИЗМЕРЕНИЯ АЧХ + доп режимы
void AFC() {
  while (ExitStat == 0) {
    GLCD.ClearScreen();
    delay(100);
    attachInterrupt(0, Display, FALLING);
    attachInterrupt(1, Display, FALLING);
    attachInterrupt(5, ChangeAFC, LOW); //активация прерывания для входа в режим изменения режима просмотра АЧХ
    attachInterrupt(4, Exit, LOW);

    if (ChangeStat == 4) {//корректируем показания маркера и значение центр частоты при возврате в основной режим АЧХ
      centrFreq = centrFreq + stepCentrFreq;
      LCDFreq = LCDFreq + stepCentrFreq / 100000.00;
    }

    //процедура расчета ширины и шага сканирования
    stepFreq = polosaFreq / 128; //определяем величину шага на 128 отсчетов
    stepMarker = polosaFreq / 128 / 100000.00; //расчет значений шага маркера для отображения частоты на ЛСД
    stepCentrFreq = polosaFreq / 2;
    stepCentrFreq1 = stepCentrFreq / 100000.00;
    centrFreq = centrFreq - stepCentrFreq;

    //ОСНОВНОЙ РЕЖИМ ИЗМЕРЕНИЯ АЧХ
    while (ExitStat == 0) {
      centrFreq1 = centrFreq; //восстанавливаем начальное значение старотовой частоты

      while (PosDot < 128) { //делаем до тех пор, пока не пройдет 128 отсчетов

        centrFreq = centrFreq + stepFreq;
        si5351.set_freq(centrFreq, SI5351_CLK0); //отправляем полученное значение на выход 0 СИ5351
        F = analogRead(A0); // считываем значение напряжения с АЦП МК

        F = map(F, 0, StartU, 63, 0);

        GLCD.SetDot(PosDot, F, BLACK); //выводим точку на экран
        PosDot = PosDot + 1;
        GLCD.DrawVLine(Marker, 16, 48, BLACK); //рисуем на ЛСД маркер
        MarkerFreq = stepMarker * Marker + LCDFreq - stepCentrFreq1; //вычислчем значение частоты в зависимости от положения маркера на графике
        GLCD.CursorTo(0, 0);
        GLCD.print(stepFreq / 100000);
        GLCD.print(" kHz");
        GLCD.CursorTo(0, 1);
        GLCD.print(MarkerFreq);
        GLCD.print(" kHz");

      }
      PosDot = 0; //переводим значение развертки графика в исходное положение
      GLCD.ClearScreen(); //очищаем экран
      centrFreq = centrFreq1; //восстанавливаем начальное значение старотовой частоты
    }

    // ФУНКЦИЯ РЕЖИМА ИЗМЕРЕНИЯ АЧХ (ИЗМЕНЕНИЕ ЦЕНТРАЛЬНОЙ ЧАСТОТЫ)
    while (ChangeStat == 2) {

      attachInterrupt(0, Encoder4, FALLING); //отработка функции энкодера для установки СТАРТОВОЙ частоты при просмотре АЧХ
      attachInterrupt(1, Encoder4, FALLING);
      attachInterrupt(5, ChangeAFC1, LOW); //активация прерывания для входа из режима изменения режима просмотра АЧХ
      detachInterrupt(4);
      PosDot = 0;
      GLCD.ClearScreen(); //очищаем экран
      LCDFreq = LCDFreq - stepCentrFreq / 100000.00; //корректируем показания маркера при переходе в режим изменения центральной частоты

      while (ChangeStat == 2) {
        NewCentrFreq = centrFreq; //восстанавливаем начальное значение старотовой частоты

        while (PosDot < 128) { //делаем до тех пор, пока не пройдет 128 отсчетов
          centrFreq = centrFreq + stepFreq; //перед каждым отсчетом увеличиваем значение частоты на полученный шаг
          si5351.set_freq(centrFreq, SI5351_CLK0); //отправляем полученное значение на выход 0 СИ5351
          F = analogRead(A0); // считываем значение напряжения с АЦП МК
          F = map(F, 0, StartU, 63, 0);

          GLCD.SetDot(PosDot, F, BLACK); //выводим точку на экран
          PosDot = PosDot + 1;

          GLCD.DrawVLine(Marker, 16, 48, BLACK); //рисуем на ЛСД маркер
          MarkerFreq = stepMarker * Marker + LCDFreq; //вычислчем значение частоты в зависимости от положения маркера на графике

          GLCD.CursorTo(0, 0); //пишем значение шага маркера на экране
          GLCD.print(stepFreq / 100000);
          GLCD.print(" kHz");

          GLCD.CursorTo(0, 1); //пишем значение частоты маркера на экране
          GLCD.print(MarkerFreq);
          GLCD.print(" kHz");

          GLCD.CursorTo(15, 0); //пишем значение частоты маркера на экране
          GLCD.print("CHG");
        }

        PosDot = 0; //переводим значение развертки графика в исходное положение
        GLCD.ClearScreen(); //очищаем экран

        centrFreq = NewCentrFreq; //восстанавливаем начальное значение старотовой частоты
      }

      // ФУНКЦИЯ РЕЖИМА изменения АМПЛИТУДЫ АЧХ
      while (ChangeStat == 3) {

        attachInterrupt(0, AMPLITUDA, FALLING); //отработка функции энкодера для установки СТАРТОВОЙ частоты при просмотре АЧХ
        attachInterrupt(1, AMPLITUDA, FALLING);
        attachInterrupt(5, ChangeAFC2, LOW); //активация прерывания для входа из режима изменения амплитуды АЧХ
        detachInterrupt(4);
        PosDot = 0;
        GLCD.ClearScreen(); //очищаем экран

        while (ChangeStat == 3) {
          centrFreq1 = centrFreq; //восстанавливаем начальное значение старотовой частоты

          while (PosDot < 128) { //делаем до тех пор, пока не пройдет 128 отсчетов
            centrFreq = centrFreq + stepFreq; //перед каждым отсчетом увеличиваем значение частоты на полученный шаг
            si5351.set_freq(centrFreq, SI5351_CLK0); //отправляем полученное значение на выход 0 СИ5351
            F = analogRead(A0); // считываем значение напряжения с АЦП МК
            F = map(F, 0, StartU, 63, 0);

            GLCD.SetDot(PosDot, F, BLACK); //выводим точку на экран
            PosDot = PosDot + 1;

            GLCD.CursorTo(15, 0); //пишем значение частоты маркера на экране
            GLCD.print("AMPL");
          }

          PosDot = 0; //переводим значение развертки графика в исходное положение
          GLCD.ClearScreen(); //очищаем экран

          centrFreq = centrFreq1;//восстанавливаем начальное значение старотовой частоты
        }
      }

    }
  }
}

void ChangeAFC() { //режим изменения режима просмотра АЧХ
  ExitStat = 1;
  ChangeStat = 2;
  PosDot = 0;
}

void ChangeAFC1() { //выход из режима изменения режима просмотра АЧХ
  ChangeStat = 3;
  ExitStat = 0;
  PosDot = 0;
}

void ChangeAFC2() { //выход из режима изменения режима просмотра АЧХ
  ChangeStat = 4;
  ExitStat = 0;
  PosDot = 0;
}

//функция отработки энкодера по выбору пункта из МЕНЮ выбора ЦЕНТРАЛЬНОЙ ЧАСТОТЫ АЧХ
void MenuGetAFC() {
  //выбор энкодером пункта меню
  encoder_A = digitalRead(2);
  encoder_B = digitalRead(3);

  if (!encoder_A && encoder_A_prev) {
    if (encoder_B) {
      if (Menu >= 14) {
        Menu = 1;
      }
      else {
        Menu++;
      }
    }
    else {
      if (Menu <= 1) {
        Menu = 14;
      }
      else {
        Menu--;
      }
    }
  }
  encoder_A_prev = encoder_A;
}

//перемещение энкодером маркера по экрану в основном режиме изм АЧХ
void Display() {
  encoder_A = digitalRead(2);
  encoder_B = digitalRead(3);
  GLCD.DrawVLine(Marker, 16, 48, WHITE); //стираем на ЛСД предыдуще положение маркера на экране

  if (!encoder_A && encoder_A_prev) {
    if (encoder_B) {
      if (Marker >= 127) {
        Marker = 0;
      }
      else {
        Marker++;
      }
    }
    else {
      if (Marker <= 0) {
        Marker = 127;
      }
      else {
        Marker--;
      }
    }
  }
  encoder_A_prev = encoder_A;
}

void Encoder4() {

  //установка энкодером стартовой частоты для режима просмотра АЧХ
  encoder_A = digitalRead(2);
  encoder_B = digitalRead(3);
  centrFreq = NewCentrFreq;

  if (!encoder_A && encoder_A_prev) {
    if (encoder_B) {
      if (centrFreq >= 40000000000) {
        centrFreq = 1000000;
        NewCentrFreq = centrFreq;
      }
      else {
        centrFreq = centrFreq + stepFreq;
        LCDFreq = (float)centrFreq / 100000.00;
        NewCentrFreq = centrFreq;
      }
    }
    else {
      if (centrFreq <= 10000000) {
        centrFreq = 4000000000;
        NewCentrFreq = centrFreq;
      }
      else {
        centrFreq = centrFreq - stepFreq;
        LCDFreq = (float)centrFreq / 100000.00;
        NewCentrFreq = centrFreq;
      }
    }
  }
  encoder_A_prev = encoder_A;
}

// Установка амплитуды АЧХ
void AMPLITUDA() {

  encoder_A = digitalRead(2);
  encoder_B = digitalRead(3);

  if (!encoder_A && encoder_A_prev) {
    if (encoder_B) {
      StartU = StartU + 10;
    }
    else {
      StartU = StartU - 10;
    }
  }
  encoder_A_prev = encoder_A;
}

//установка энкодером стартовой частоты
void Encoder2() {

  encoder_A = digitalRead(2);
  encoder_B = digitalRead(3);

  if (!encoder_A && encoder_A_prev) {
    if (encoder_B) {
      if (centrFreq >= 4000000000) {
        centrFreq = 10000000;
      }
      else {
        centrFreq = centrFreq + Step;
        LCDFreq = (float)centrFreq / 100000.00;
        GLCD.CursorTo(0, 3);
        GLCD.print(LCDFreq);
        GLCD.print(" kHz");
        GLCD.ClearScreen();
      }

    }
    else {
      if (centrFreq <= 10000000) {
        centrFreq = 4000000000;
      }
      else {
        centrFreq = centrFreq - Step;
        LCDFreq = (float)centrFreq / 100000.00;
        GLCD.CursorTo(0, 3);
        GLCD.print(LCDFreq);
        GLCD.print(" kHz");
        GLCD.ClearScreen();
      }
    }
  }
  encoder_A_prev = encoder_A;
  startFreq = centrFreq;
}

//установка энкодером ШИРИНЫ частоты сканирования
void Encoder3() {

  encoder_A = digitalRead(2);
  encoder_B = digitalRead(3);

  if (!encoder_A && encoder_A_prev) {
    if (encoder_B) {
      if (polosaFreq >= 4000000000) {
        polosaFreq = 10000000;
      }
      else {
        polosaFreq = polosaFreq + Step;
        LCDFreq2 = (float)polosaFreq / 100000.00;
        GLCD.CursorTo(0, 3);
        GLCD.print(LCDFreq2);
        GLCD.print(" kHz");
        GLCD.ClearScreen();
      }
    }
    else {
      if (polosaFreq <= 10000000) {
        polosaFreq = 4000000000;
      }
      else {
        polosaFreq = polosaFreq - Step;
        LCDFreq2 = (float)polosaFreq / 100000.00;
        GLCD.print(LCDFreq2);
        GLCD.print(" kHz");
        GLCD.ClearScreen();
      }
    }
  }
  encoder_A_prev = encoder_A;
}



void Exit() {
  GLCD.SelectFont(Callibri11_bold);
  GLCD.ClearScreen(); //очищаем экран
  //  Menu = 1;
  ExitStat = 1;
  ExitMark = 1;
  PosDot = 128;
  return;
}

void Exit2() {
  //  Step = 100000;
  //  centrFreq = 1070000000;
  Menu = 1;
  GLCD.ClearScreen(); //очищаем экран
  ExitStat2 = 1;
  return;
}

void Exit3() {
  Menu = 1;
  GLCD.ClearScreen(); //очищаем экран
  ExitStat3 = 1;
  return;
}

void BAND_160() {
  GLCD.SelectFont(System5x7); //шрифт текста
  LCDFreq =  1800.00;
  centrFreq = 180000000;
  polosaFreq = 30000000;
  WIDT();
}

void BAND_80() {
  GLCD.SelectFont(System5x7); //шрифт текста
  LCDFreq =  3600.00;
  centrFreq = 360000000;
  polosaFreq = 30000000;
  WIDT();
}

void BAND_40() {
  GLCD.SelectFont(System5x7); //шрифт текста
  LCDFreq =  7100.00;
  centrFreq = 710000000;
  polosaFreq = 20000000;
  WIDT();
}

void BAND_20() {
  GLCD.SelectFont(System5x7); //шрифт текста
  LCDFreq =  14100.00;
  centrFreq = 1420000000;
  polosaFreq = 40000000;
  WIDT();
}

void BAND_15() {
  GLCD.SelectFont(System5x7); //шрифт текста
  LCDFreq =  21250.00;
  centrFreq = 2125000000;
  polosaFreq = 40000000;
  WIDT();
}

void BAND_10() {
  GLCD.SelectFont(System5x7); //шрифт текста
  LCDFreq =  29000.00;
  centrFreq = 2900000000;
  polosaFreq = 100000000;
  WIDT();
}

void FILTRE_455() {
  GLCD.SelectFont(System5x7); //шрифт текста
  LCDFreq =  455.00;
  centrFreq = 45500000;
  polosaFreq = 1500000;
  WIDT();
}

void FILTRE_465() {
  GLCD.SelectFont(System5x7); //шрифт текста
  LCDFreq =  465.00;
  centrFreq = 46500000;
  polosaFreq = 1500000;
  WIDT();
}

void FILTRE_500() {
  GLCD.SelectFont(System5x7); //шрифт текста
  LCDFreq =  500.00;
  centrFreq = 50000000;
  polosaFreq = 1500000;
  WIDT();
}

void FILTRE_5_5() {
  GLCD.SelectFont(System5x7); //шрифт текста
  LCDFreq =  5500.00;
  centrFreq = 550000000;
  polosaFreq = 50000000;
  WIDT();
}

void FILTRE_6_5() {
  GLCD.SelectFont(System5x7); //шрифт текста
  LCDFreq =  6500.00;
  centrFreq = 650000000;
  polosaFreq = 50000000;
  WIDT();
}

void FILTRE_8_86() {
  GLCD.SelectFont(System5x7); //шрифт текста
  LCDFreq =  8860.00;
  centrFreq = 886000000;
  polosaFreq = 10000000;
  WIDT();
}

void FILTRE_10_7() {
  GLCD.SelectFont(System5x7); //шрифт текста
  LCDFreq =  10700.00;
  centrFreq = 1070000000;
  polosaFreq = 50000000;
  WIDT();
}

